#include "BCodeTerminal.h"
#include "DeviceHubWindow.h"
#include <iostream>
#include <QDateTime>

BCodeTerminal::BCodeTerminal(QObject* parent) : DeviceBase(parent)
{
    this->devType = "07";
    connect(&this->serialUtil, &QSerialPortUtil::dataRecieved,
            this, &BCodeTerminal::dataReceivedHandler);

    connect(this, &BCodeTerminal::sendDataToDraw,
            ((DeviceHubWindow *)this->parent())->bCodeTermForm, &BCodeTerminalForm::drawDeviceFrameOnForm);
    connect(this, &BCodeTerminal::sendCommandToDisplay,
            ((DeviceHubWindow *)this->parent())->bCodeTermForm, &BCodeTerminalForm::displayDeviceCommandOnForm);

    connect(((DeviceHubWindow *)this->parent())->kafkaConsumer, &QKafkaConsumer::messageRecieved,
            this, &BCodeTerminal::commandReceivedHandler);

    kafkaProducer.setBrokers(SettingConfig::getInstance().KAFKA_BROKERS);
    kafkaProducer.setTopic(SettingConfig::getInstance().KAFKA_DATA_TOPIC);
    kafkaProducer.createProducer();

    this->protocol = DeviceProtocolBase::deviceProtocolFactory(devType);
}

BCodeTerminal::~BCodeTerminal()
{
    disconnect(&this->serialUtil, &QSerialPortUtil::dataRecieved,
               this, &BCodeTerminal::dataReceivedHandler);
}

void BCodeTerminal::mockReceivData()
{
    QByteArray buffer;

    // b-code terminal
    buffer.append("$2521304-20 210100112111ff1210.0311d0*");
//    buffer.append("$3e21304-20 2101001111304-20 2101001210801H.1.00S.1.030008432*");

    this->dataReceivedHandler(buffer);
}

void BCodeTerminal::mockReceivCmdReply()
{
    QByteArray buffer;

    // bcode term
    buffer.append("$1941308-20 21010021053d*");
    this->dataReceivedHandler(buffer);
}

void BCodeTerminal::dataReceivedHandler(QByteArray data)
{
    this->dataBuff.append(data);
    std::cout << dataBuff.toStdString() << std::endl;

    QList<QByteArray> frameList = protocol->extractFrameList(this->dataBuff);
    if (frameList.size() > 0)
    {
        this->dataBuff.clear();
        for (int i = 0; i < frameList.size(); i++)
        {
            QByteArray frameByte = frameList.at(i);

            int frameType = protocol->checkFrame(frameByte);
            DeviceFrameBaseDto * frameDto = protocol->frameFactory(frameType);
            if (frameDto != nullptr)
            {
                // ★解析成数据对象
                bool parse = protocol->parseDeviceFrameData(frameByte, frameDto, frameType);

                // 解析成功
                if (parse == true)
                {
                    QDateTime now = QDateTime::currentDateTime();
                    frameDto->timestamp = now.toString("yyyy-MM-dd HH:mm:ss.zzz");
                    frameDto->milisecond = now.toMSecsSinceEpoch();
                    frameDto->rawFrame = frameByte;

                    frameDto->devCode = devCode;

                    if (frameType == BCodeTerminalProtocolBM::BCODE_TERMINAL_FRAME_TYPE::STATUS_FRAME)
                    {
                        this->afterFrameParse(frameDto);
                    }

                    if (frameType == BCodeTerminalProtocolBM::BCODE_TERMINAL_FRAME_TYPE::CMDREP_FRAME)
                    {
                        frameDto->rawCommand = rawCommandBytes;
                        frameDto->commandId = commandId;
                        this->afterCommandReply(frameDto);
                    }
                }

                // 在此处释放内存，不影响后续显示
                // 不在此处释放内存则会导致内存持续增加
                // 具体原因不明
                delete frameDto;
            }
        }
    }
}

void BCodeTerminal::afterFrameParse(DeviceFrameBaseDto * frameDto)
{
//    std::cout << "frame type: " << typeid(* frameDto).name() << std::endl;
//    std::cout << frameDto->rawFrame.toStdString() << std::endl;

    // 0. 输出到日志文件中
    QString date = frameDto->timestamp.mid(0, 10);

    // 1. 原始字节数组数据
    QString filename = "raw_" + devCode + ".log";
    QString content = frameDto->timestamp + " [recv] " + frameDto->rawFrame.left(frameDto->rawFrame.size());
    QLogUtil::writeRawDataLogByDate(date, filename, content);

    // 2. 解析后的json数据
    QString frameFilename = "frame_" + devCode + ".log";
    QString frameContent = frameDto->timestamp + " [recv] " + QJsonDocument(frameDto->toJSON()).toJson(QJsonDocument::Compact);
    QLogUtil::writeChannelDataLogByDate(date, frameFilename, frameContent);

    // 3. 输出到中间件，执行后续处理过程
    if (SettingConfig::getInstance().NEED_KAFKA == 1)
    {
        QJsonObject jsonObj = frameDto->toJSON();
        jsonObj.insert("clientId", SettingConfig::getInstance().CLIENT_ID);
        jsonObj.insert("master", SettingConfig::getInstance().MASTER);
        jsonObj.insert("deviceId", deviceId);
        kafkaProducer.produceMessage(QString(QJsonDocument(jsonObj).toJson(QJsonDocument::Compact)));
    }

    // 4. 在界面上简单显示相差数据结果
    emit this->sendDataToDraw(frameDto);
}

void BCodeTerminal::afterCommandReply(DeviceFrameBaseDto * frameDto)
{
    // 0. 输出到日志文件中
    QString date = frameDto->timestamp.mid(0, 10);

    // 1. 原始字节数组数据
    QString filename = "raw_" + devCode + ".log";
    QString content = frameDto->timestamp + " [recv] " + frameDto->rawFrame.left(frameDto->rawFrame.size());
    QLogUtil::writeRawDataLogByDate(date, filename, content);

    // 2. 解析后的json数据
    QString frameFilename = "frame_" + devCode + ".log";
    QString frameContent = frameDto->timestamp + " [reply] " + QJsonDocument(frameDto->toJSON()).toJson(QJsonDocument::Compact);
    QLogUtil::writeChannelDataLogByDate(date, frameFilename, frameContent);

    // 3. 输出到中间件，执行后续处理过程
    if (SettingConfig::getInstance().NEED_KAFKA == 1)
    {
        QJsonObject jsonObj = frameDto->toJSON();
        kafkaProducer.produceMessage(SettingConfig::getInstance().KAFKA_CMDCB_TOPIC, QString(QJsonDocument(jsonObj).toJson(QJsonDocument::Compact)));
    }
}

void BCodeTerminal::sendDataToSerial(QByteArray data)
{
    CommandReplyDto replyDto;
    replyDto.devCode = devCode;
    replyDto.commandId = commandId;
    replyDto.rawCommand = rawCommandBytes;

    data.append(FRAME_TAIL);
    if (SettingConfig::getInstance().WORK_MODE == "real")
    {
        if (serialUtil.isOpen() == true)
        {
            this->serialUtil.sendData(data);
        } else if (serialUtilB.isOpen() == true)
        {
            this->serialUtilB.sendData(data);
        } else
        {
            replyDto.cmdStatus = 0;
            replyDto.remarks = "serialport not avilable";

            // 3. 输出到中间件，执行后续处理过程
            if (SettingConfig::getInstance().NEED_KAFKA == 1)
            {
                kafkaProducer.produceMessage(SettingConfig::getInstance().KAFKA_CMDCB_TOPIC,
                                             QString(QJsonDocument(replyDto.toJSON()).toJson(QJsonDocument::Compact)));
            }
            return;
        }
    }


    // 记录日志
    // 0. 输出到日志文件中
    QDateTime now = QDateTime::currentDateTime();
    QString date = now.toString("yyyy-MM-dd");

    // 1. 原始字节数组数据
    QString filename = "rawCmd_" + devCode + ".log";
    QString content = now.toString("yyyy-MM-dd HH:mm:ss.zzz") + " [send] " + data.left(data.size() - FRAME_TAIL.size());
    QLogUtil::writeRawDataLogByDate(date, filename, content);

    std::cout << content.toStdString() << std::endl;
}

void BCodeTerminal::commandReceivedHandler(QJsonObject command)
{
    if (command.contains("deviceType") == false || command.value("deviceType").toString() != "07")
    {
        return;
    }

    if (command.contains("deviceId") == false || command.value("deviceId").toString() != deviceId)
    {
        return;
    }

    // 记录日志
    // 0. 输出到日志文件中
    QDateTime now = QDateTime::currentDateTime();
    QString date = now.toString("yyyy-MM-dd");

    // 1. 原始字节数组数据
    QString filename = "cmd_" + devCode + ".log";
    QString content = now.toString("yyyy-MM-dd HH:mm:ss.zzz") + " [recv] " + command.find("cmdStr")->toString();
    QLogUtil::writeChannelDataLogByDate(date, filename, content);

    QByteArray commandBytes = protocol->generateSettingCommand(devCode, command.value("command").toString(), command.value("params").toString());
    command.insert("rawCommand", QString::fromUtf8(commandBytes));
    this->commandId = command.value("commandId").toString();
    this->rawCommandBytes = commandBytes;
    this->sendDataToSerial(commandBytes);

    // display on page
    emit sendCommandToDisplay(command);
}
